diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericAxis.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericAxis.java
new file mode 100644
index 000000000..3f96ef175
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericAxis.java
@@ -0,0 +1,41 @@
+package net.minecraft.client.render.block.model.generic;
+
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.block.BlockLogicAxisAligned;
+import net.minecraft.core.util.helper.Axis;
+import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.useless.dragonfly.data.block.BlockModelData;
+import org.useless.dragonfly.models.block.StaticBlockModel;
+
+public class BlockModelGenericAxis<T extends BlockLogic> extends BlockModelGeneric<T> {
+    public BlockModelGenericAxis(@NotNull Block<T> block, @NotNull StaticBlockModel staticModel) {
+        super(block, staticModel);
+    }
+
+    public BlockModelGenericAxis(@NotNull Block<T> block, @NotNull BlockModelData staticModel) {
+        super(block, staticModel);
+    }
+
+    @Override
+    public boolean renderAttached(@NotNull TessellatorGeneral tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos, boolean cullFaces, @Nullable IconCoordinate overrideTexture) {
+        Axis axis = BlockLogicAxisAligned.metaToAxis(worldSource.getBlockData(tilePos));
+        switch (axis) {
+            case X -> {
+                return getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 0, 1, 1, 0, 0, 0, false, cullFaces, overrideTexture);
+            }
+            case Y -> {
+                return getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 0, 0, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+            }
+            case Z -> {
+                return getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 1, 0, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+            }
+        }
+        return false;
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericBasket.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericBasket.java
new file mode 100644
index 000000000..1ca363756
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericBasket.java
@@ -0,0 +1,30 @@
+package net.minecraft.client.render.block.model.generic;
+
+import net.minecraft.client.render.block.model.BlockModelDispatcher;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogicBasket;
+import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.useless.dragonfly.models.block.StaticBlockModel;
+
+public class BlockModelGenericBasket<T extends BlockLogicBasket> extends BlockModelGeneric<T> {
+    public final @NotNull StaticBlockModel fill;
+    public BlockModelGenericBasket(@NotNull Block<T> block) {
+        super(block, BlockModelDispatcher.loadDataModel("minecraft:block/basket"));
+        this.fill = BlockModelDispatcher.loadDataModel("minecraft:block/basket_fill").asModel();
+    }
+
+    @Override
+    public boolean renderAttached(@NotNull TessellatorGeneral tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos, boolean cullFaces, @Nullable IconCoordinate overrideTexture) {
+        boolean rendered = super.renderAttached(tessellator, worldSource, tilePos, cullFaces, overrideTexture);
+        final int height = this.block.getLogic().getFillLevel(worldSource, tilePos);
+        if (height > 0) {
+            rendered |= this.fill.renderAttached(this, tessellator, worldSource, tilePos, 0, 0, 0, 0, (height)/16f, 0, false, cullFaces, overrideTexture);
+        }
+        return rendered;
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericBed.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericBed.java
new file mode 100644
index 000000000..b97790131
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericBed.java
@@ -0,0 +1,37 @@
+package net.minecraft.client.render.block.model.generic;
+
+import net.minecraft.client.render.block.model.BlockModelDispatcher;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.block.BlockLogicBed;
+import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.useless.dragonfly.models.block.StaticBlockModel;
+
+public class BlockModelGenericBed<T extends BlockLogic> extends BlockModelGeneric<T> {
+    public final @NotNull StaticBlockModel head;
+    public BlockModelGenericBed(Block<T> block) {
+        super(block, BlockModelDispatcher.loadDataModel("minecraft:block/bed/foot"));
+        this.head = BlockModelDispatcher.loadDataModel("minecraft:block/bed/head").asModel();
+    }
+
+    @Override
+    public boolean renderAttached(@NotNull TessellatorGeneral tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos, boolean cullFaces, @Nullable IconCoordinate overrideTexture) {
+        int direction = BlockLogicBed.getDirection(worldSource.getBlockData(tilePos));
+        return switch (direction) {
+            case 0 -> getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 0, 3, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+            case 1 -> getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 0, 2, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+            case 2 -> getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 0, 1, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+            default -> getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 0, 0, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+        };
+    }
+
+    @Override
+    public @NotNull StaticBlockModel getModelFromData(int data) {
+        return BlockLogicBed.isBlockHeadOfBed(data) ? this.head : this.staticModel;
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericBrazier.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericBrazier.java
new file mode 100644
index 000000000..b48684d6f
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericBrazier.java
@@ -0,0 +1,36 @@
+package net.minecraft.client.render.block.model.generic;
+
+import net.minecraft.client.render.block.model.BlockModelFire;
+import net.minecraft.client.render.block.model.BlockModelStandard;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.useless.dragonfly.data.block.BlockModelData;
+import org.useless.dragonfly.models.block.StaticBlockModel;
+
+public class BlockModelGenericBrazier<T extends BlockLogic> extends BlockModelGeneric<T> {
+    protected BlockModelStandard<?> fireModel = new BlockModelFire<>(Blocks.FIRE, true).setAllTextures("minecraft:block/fire");
+
+    public BlockModelGenericBrazier(@NotNull Block<T> block, @NotNull StaticBlockModel staticModel) {
+        super(block, staticModel);
+    }
+
+    public BlockModelGenericBrazier(@NotNull Block<T> block, @NotNull BlockModelData staticModel) {
+        super(block, staticModel);
+    }
+
+    @Override
+    public boolean renderAttached(@NotNull TessellatorGeneral tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos, boolean cullFaces, @Nullable IconCoordinate overrideTexture) {
+        boolean rendered = super.renderAttached(tessellator, worldSource, tilePos, cullFaces, overrideTexture);
+        if (overrideTexture == null) {
+            rendered |= this.fireModel.render(tessellator, worldSource, tilePos);
+        }
+        return rendered;
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericButton.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericButton.java
new file mode 100644
index 000000000..892a08f49
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericButton.java
@@ -0,0 +1,42 @@
+package net.minecraft.client.render.block.model.generic;
+
+import net.minecraft.client.render.block.model.BlockModelDispatcher;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.block.BlockLogicButton;
+import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.useless.dragonfly.models.block.StaticBlockModel;
+
+public class BlockModelGenericButton<T extends BlockLogic> extends BlockModelGeneric<T> {
+    public final @NotNull StaticBlockModel idle;
+    public final @NotNull StaticBlockModel active;
+    public BlockModelGenericButton(@NotNull Block<T> block, @NotNull String basekey) {
+        super(block, BlockModelDispatcher.loadDataModel(basekey + "/inventory"));
+        this.idle = BlockModelDispatcher.loadDataModel(basekey + "/idle").asModel();
+        this.active = BlockModelDispatcher.loadDataModel(basekey + "/active").asModel();
+    }
+
+    @Override
+    public boolean renderAttached(@NotNull TessellatorGeneral tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos, boolean cullFaces, @Nullable IconCoordinate overrideTexture) {
+        int direction = worldSource.getBlockData(tilePos) & BlockLogicButton.MASK_DIRECTION;
+        return switch (direction) {
+            case BlockLogicButton.SIDE_WEST -> getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 1, 1, 0, 0, 0, 0, true, cullFaces, overrideTexture);
+            case BlockLogicButton.SIDE_EAST -> getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 1, 3, 0, 0, 0, 0, true, cullFaces, overrideTexture);
+            case BlockLogicButton.SIDE_NORTH -> getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 1, 0, 0, 0, 0, 0, true, cullFaces, overrideTexture);
+            case BlockLogicButton.SIDE_SOUTH -> getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 1, 2, 0, 0, 0, 0, true, cullFaces, overrideTexture);
+            case BlockLogicButton.SIDE_TOP -> getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 2, 0, 0, 0, 0, 0, true, cullFaces, overrideTexture);
+            default -> getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 0, 0, 0, 0, 0, 0, true, cullFaces, overrideTexture);
+        };
+    }
+
+    @Override
+    public @NotNull StaticBlockModel getModel(@NotNull WorldSource source, @NotNull TilePosc tilePosc) {
+        boolean pressed = (source.getBlockData(tilePosc) & BlockLogicButton.MASK_POWERED) != 0;
+        return pressed ? this.active : this.idle;
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericButtonPainted.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericButtonPainted.java
new file mode 100644
index 000000000..3f597f140
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericButtonPainted.java
@@ -0,0 +1,41 @@
+package net.minecraft.client.render.block.model.generic;
+
+import net.minecraft.client.render.block.model.BlockModelDispatcher;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.block.BlockLogicButton;
+import net.minecraft.core.util.helper.DyeColor;
+import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.useless.dragonfly.models.block.StaticBlockModel;
+
+public class BlockModelGenericButtonPainted<T extends BlockLogic> extends BlockModelGenericButton<T> {
+    public final @NotNull StaticBlockModel[] inventory = new StaticBlockModel[DyeColor.COLOR_AMOUNT];
+    public final @NotNull StaticBlockModel[] idle = new StaticBlockModel[DyeColor.COLOR_AMOUNT];
+    public final @NotNull StaticBlockModel[] active = new StaticBlockModel[DyeColor.COLOR_AMOUNT];
+    public BlockModelGenericButtonPainted(@NotNull Block<T> block) {
+        super(block, "minecraft:block/button/planks/white");
+        for (DyeColor color : DyeColor.blockOrderedColors()) {
+            this.inventory[color.blockMeta] = BlockModelDispatcher.loadDataModel("minecraft:block/button/planks/" + color.colorID + "/inventory").asModel();
+            this.idle[color.blockMeta] = BlockModelDispatcher.loadDataModel("minecraft:block/button/planks/" + color.colorID + "/idle").asModel();
+            this.active[color.blockMeta] = BlockModelDispatcher.loadDataModel("minecraft:block/button/planks/" + color.colorID + "/active").asModel();
+        }
+    }
+
+    @Override
+    public @NotNull StaticBlockModel getModel(@NotNull WorldSource source, @NotNull TilePosc tilePosc) {
+        int data = source.getBlockData(tilePosc);
+        int color = (data >> 4) & DyeColor.MASK_COLOR;
+        boolean pressed = (data & BlockLogicButton.MASK_POWERED) != 0;
+        return pressed ? this.active[color] : this.idle[color];
+    }
+
+    @Override
+    public @NotNull StaticBlockModel getModelFromData(int data) {
+        return this.inventory[(data >> 4) & DyeColor.MASK_COLOR];
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericCake.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericCake.java
new file mode 100644
index 000000000..be61fa99e
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericCake.java
@@ -0,0 +1,23 @@
+package net.minecraft.client.render.block.model.generic;
+
+import net.minecraft.client.render.block.model.BlockModelDispatcher;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
+import org.jetbrains.annotations.NotNull;
+import org.useless.dragonfly.models.block.StaticBlockModel;
+
+public class BlockModelGenericCake<T extends BlockLogic> extends BlockModelGeneric<T> {
+    public final StaticBlockModel[] models = new StaticBlockModel[6];
+    public BlockModelGenericCake(@NotNull Block<T> block) {
+        super(block, BlockModelDispatcher.loadDataModel("minecraft:block/cake/0"));
+        for (int i = 0; i < this.models.length; i++) {
+            this.models[i] = BlockModelDispatcher.loadDataModel("minecraft:block/cake/" + i).asModel();
+        }
+    }
+
+
+    @Override
+    public @NotNull StaticBlockModel getModelFromData(int data) {
+        return this.models[data % this.models.length];
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericChest.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericChest.java
new file mode 100644
index 000000000..6dbfe9e0f
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericChest.java
@@ -0,0 +1,55 @@
+package net.minecraft.client.render.block.model.generic;
+
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.block.BlockLogicChest;
+import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.useless.dragonfly.data.block.BlockModelData;
+import org.useless.dragonfly.models.block.StaticBlockModel;
+
+public class BlockModelGenericChest<T extends BlockLogic> extends BlockModelGeneric<T> {
+    public final @NotNull StaticBlockModel left;
+    public final @NotNull StaticBlockModel right;
+
+    public BlockModelGenericChest(@NotNull Block<T> block, @NotNull BlockModelData single, @NotNull BlockModelData left, @NotNull BlockModelData right) {
+        super(block, single);
+        this.left = left.asModel();
+        this.right = right.asModel();
+    }
+
+    @Override
+    public boolean renderAttached(@NotNull TessellatorGeneral tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos, boolean cullFaces, @Nullable IconCoordinate overrideTexture) {
+        Direction direction = BlockLogicChest.getDirectionFromMeta(worldSource.getBlockData(tilePos));
+        switch (direction) {
+            case NORTH -> {
+                return getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 0, 0, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+            }
+            case WEST -> {
+                return getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 0, 1, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+            }
+            case EAST -> {
+                return getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 0, 3, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+            }
+            case SOUTH -> {
+                return getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 0, 2, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+            }
+        }
+        return getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 0, 0, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+    }
+
+    @Override
+    public @NotNull StaticBlockModel getModel(@NotNull WorldSource source, @NotNull TilePosc tilePosc) {
+        BlockLogicChest.Type type = BlockLogicChest.getTypeFromMeta(source.getBlockData(tilePosc));
+        return switch (type) {
+            case LEFT -> this.left;
+            case RIGHT -> this.right;
+            case SINGLE -> this.staticModel;
+        };
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericChestPainted.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericChestPainted.java
new file mode 100644
index 000000000..377674c03
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericChestPainted.java
@@ -0,0 +1,67 @@
+package net.minecraft.client.render.block.model.generic;
+
+import net.minecraft.client.render.block.model.BlockModelDispatcher;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.block.BlockLogicChest;
+import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.util.helper.DyeColor;
+import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.useless.dragonfly.models.block.StaticBlockModel;
+
+public class BlockModelGenericChestPainted<T extends BlockLogic> extends BlockModelGeneric<T> {
+    public final @NotNull StaticBlockModel[] single = new StaticBlockModel[DyeColor.COLOR_AMOUNT];
+    public final @NotNull StaticBlockModel[] left = new StaticBlockModel[DyeColor.COLOR_AMOUNT];
+    public final @NotNull StaticBlockModel[] right = new StaticBlockModel[DyeColor.COLOR_AMOUNT];
+    public BlockModelGenericChestPainted(@NotNull Block<T> block) {
+        super(block, BlockModelDispatcher.loadDataModel("minecraft:block/chest/single/" + DyeColor.WHITE.colorID));
+        for (DyeColor c : DyeColor.blockOrderedColors()) {
+            this.single[c.blockMeta] = BlockModelDispatcher.loadDataModel("minecraft:block/chest/single/" + c.colorID).asModel();
+            this.left[c.blockMeta] = BlockModelDispatcher.loadDataModel("minecraft:block/chest/left/" + c.colorID).asModel();
+            this.right[c.blockMeta] = BlockModelDispatcher.loadDataModel("minecraft:block/chest/right/" + c.colorID).asModel();
+        }
+    }
+
+    @Override
+    public boolean renderAttached(@NotNull TessellatorGeneral tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos, boolean cullFaces, @Nullable IconCoordinate overrideTexture) {
+        Direction direction = BlockLogicChest.getDirectionFromMeta(worldSource.getBlockData(tilePos));
+        switch (direction) {
+            case NORTH -> {
+                return getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 0, 0, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+            }
+            case WEST -> {
+                return getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 0, 1, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+            }
+            case EAST -> {
+                return getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 0, 3, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+            }
+            case SOUTH -> {
+                return getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 0, 2, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+            }
+        }
+        return getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 0, 0, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+    }
+
+    @Override
+    public @NotNull StaticBlockModel getModel(@NotNull WorldSource source, @NotNull TilePosc tilePosc) {
+        int data = source.getBlockData(tilePosc);
+        int color = data >> 4;
+        BlockLogicChest.Type type = BlockLogicChest.getTypeFromMeta(data);
+        return switch (type){
+            case LEFT -> this.left[color];
+            case RIGHT -> this.right[color];
+            case SINGLE -> this.single[color];
+        };
+    }
+
+    @Override
+    public @NotNull StaticBlockModel getModelFromData(int data) {
+        int color = data >> 4;
+        return this.single[color];
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericCropsPumpkin.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericCropsPumpkin.java
new file mode 100644
index 000000000..a49d410c1
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericCropsPumpkin.java
@@ -0,0 +1,32 @@
+package net.minecraft.client.render.block.model.generic;
+
+import net.minecraft.client.render.block.model.BlockModelDispatcher;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.useless.dragonfly.models.block.StaticBlockModel;
+
+public class BlockModelGenericCropsPumpkin<T extends BlockLogic> extends BlockModelGeneric<T> {
+    public final StaticBlockModel[] stages = new StaticBlockModel[4];
+    public BlockModelGenericCropsPumpkin(@NotNull Block<T> block) {
+        super(block, BlockModelDispatcher.loadDataModel("minecraft:block/crops_pumpkin/leaf"));
+        for (int i = 0; i < this.stages.length; i++) {
+            this.stages[i] = BlockModelDispatcher.loadDataModel("minecraft:block/crops_pumpkin/stage" + (i + 1)).asModel();
+        }
+    }
+
+    @Override
+    public boolean renderAttached(@NotNull TessellatorGeneral tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos, boolean cullFaces, @Nullable IconCoordinate overrideTexture) {
+        boolean didRender = getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 0, 0, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+        int data = worldSource.getBlockData(tilePos);
+        if (data >= 1) {
+            this.stages[(data - 1) & 0b11].renderAttached(this, tessellator, worldSource, tilePos, 0, 0, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+        }
+        return didRender;
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericCropsWheat.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericCropsWheat.java
new file mode 100644
index 000000000..ba3b3b66a
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericCropsWheat.java
@@ -0,0 +1,23 @@
+package net.minecraft.client.render.block.model.generic;
+
+import net.minecraft.client.render.block.model.BlockModelDispatcher;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.block.BlockLogicCropsWheat;
+import org.jetbrains.annotations.NotNull;
+import org.useless.dragonfly.models.block.StaticBlockModel;
+
+public class BlockModelGenericCropsWheat<T extends BlockLogic> extends BlockModelGeneric<T> {
+    public final StaticBlockModel[] models = new StaticBlockModel[BlockLogicCropsWheat.MAX_GROWTH_STATE + 1];
+    public BlockModelGenericCropsWheat(@NotNull Block<T> block) {
+        super(block, BlockModelDispatcher.loadDataModel("minecraft:block/crops_wheat/stage0"));
+        for (int i = 0; i < this.models.length; i++) {
+            this.models[i] = BlockModelDispatcher.loadDataModel("minecraft:block/crops_wheat/stage" + i).asModel();
+        }
+    }
+
+    @Override
+    public @NotNull StaticBlockModel getModelFromData(int data) {
+        return this.models[data % this.models.length];
+    }
+}
